searchNodes=[{"doc":"Catches SIGTERM signal to gracefully stop the system. By default, a SIGTERM signal triggers a System.stop/0 . When running in a Kubernetes-managed cluster or an infrastructure alike, the nodes will be joining and leaving the cluster when auto-scaling is enabled or when deploying new version of the application. You should let the system to gracefully stop in combination with readiness probe you can make sure that the system is ready to stop without a relying on a SIGKILL signal. You can read more about this at Termination of Pods . When a SIGTERM is received, the handler enters &quot;connection draining mode&quot;, during which get_status/0 starts returning :draining status, and then, after a delay, the handler calls System.stop/1 , carefully halting the Erlang VM and starts returning :stopping status.","ref":"OnePiece.GracefulShutdown.html","title":"OnePiece.GracefulShutdown","type":"module"},{"doc":"Returns a specification to start OnePiece.GracefulShutdown under a supervisor. See the &quot;Child specification&quot; section in the Supervisor module for more detailed information.","ref":"OnePiece.GracefulShutdown.html#child_spec/1","title":"OnePiece.GracefulShutdown.child_spec/1","type":"function"},{"doc":"Returns the status of the system.","ref":"OnePiece.GracefulShutdown.html#get_status/0","title":"OnePiece.GracefulShutdown.get_status/0","type":"function"},{"doc":"Returns true if the system is in the :running status.","ref":"OnePiece.GracefulShutdown.html#running?/0","title":"OnePiece.GracefulShutdown.running?/0","type":"function"},{"doc":"Configuration options for the server. shutdown_delay_ms : milliseconds before draining the VM after SIGTERM . milliseconds between start of connection draining and ordered shut-down using System.stop/0 . notify_pid : process ID to notify when the server started draining. init_stop? : whether to call :System.stop/1 when a SIGTERM is received. Useful for testing since we don't want to stop the VM when testing. Be careful when using this option since it should always be true in production.","ref":"OnePiece.GracefulShutdown.html#t:opts/0","title":"OnePiece.GracefulShutdown.opts/0","type":"type"},{"doc":"The state of system. :draining - the node is draining and will be shutdown after the delay. :stopping - the node is shutting down. :running - the node is accepting work.","ref":"OnePiece.GracefulShutdown.html#t:status/0","title":"OnePiece.GracefulShutdown.status/0","type":"type"},{"doc":"A Plug module provides the functionality to check the readiness of the application using OnePiece.GracefulShutdown . When OnePiece.GracefulShutdown receive a SIGTERM signal and the system will consider not to be running, the Plug will start sending 503 response to the clients. Configuration Required OnePiece.GracefulShutdown must be also be started, or else this plug will fail at runtime. Make sure to register OnePiece.GracefulShutdown in your application supervisor. Kubernetes Configuration Use the /readiness endpoint as the readinessProbe in your Pod's configuration, e.g.: containers: readinessProbe: httpGet: path: /readiness initialDelaySeconds: 20 periodSeconds: 2 periodSeconds above means that /readiness will be polled every 2 seconds, you should take into account when setting the delay in OnePiece.GracefulShutdown , as not to shut-down before the K8S load-balancers have noticed that the endpoint has started rejecting traffic, allowing any pending requests to complete thereafter.","ref":"OnePiece.GracefulShutdown.Plug.ReadinessProbe.html","title":"OnePiece.GracefulShutdown.Plug.ReadinessProbe","type":"module"},{"doc":"Catches SIGTERM signal to gracefully stop the system.","ref":"readme.html","title":"OnePiece.GracefulShutdown","type":"extras"},{"doc":"References API Reference","ref":"readme.html#documentation","title":"OnePiece.GracefulShutdown - Documentation","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Initial commit","ref":"changelog.html#v0-0-1-2020-08-21","title":"Changelog - v0.0.1 - 2020-08-21","type":"extras"}]